org.jgroups.protocols

## Class FILE_PING

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.Discovery
    - - org.jgroups.protocols.FILE_PING

- Direct Known Subclasses:
    JDBC_PING, S3_PING

      public class FILE_PING
      extends Discovery

  Simple discovery protocol which uses a file on shared storage such as an SMB share, NFS mount or S3. The local address information, e.g. UUID and physical addresses mappings are written to the file and the content is read and added to our transport's UUID-PhysicalAddress cache.

  The design is at doc/design/FILE_PING.txt
  Author:
    Bela Ban

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `FILE_PING.WriterTask`

    - ### Nested classes/interfaces inherited from class org.jgroups.protocols.Discovery

      `Discovery.Responses`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.io.FilenameFilter` | `filter`
    `protected long` | `interval`
    `protected java.lang.String` | `location`
    `protected java.io.File` | `root_dir`
    `protected static java.lang.String` | `SUFFIX`

    - ### Fields inherited from class org.jgroups.protocols.Discovery

      `group_addr, local_addr, members, ping_responses, rank, timer, view`

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FILE_PING()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.String` | `addressAsString(Address address)`
    `protected void` | `createRootDir()`
    `java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
    `protected void` | `handleView(View view)`
    `void` | `init()` Called after instance has been created (null constructor) and before protocol is started.
    `protected java.util.List<PingData>` | `readAll(java.lang.String clustername)` Reads all information from the given directory under clustername
    `protected static PingData` | `readFile(java.io.File file)`
    `protected void` | `remove(java.lang.String clustername, Address addr)`
    `void` | `sendGetMembersRequest(java.lang.String cluster_name, Promise promise, boolean return_views_only)`
    `void` | `start()` This method is called on a `Channel.connect(String)`.
    `void` | `stop()` This method is called on a `Channel.disconnect()`.
    `protected void` | `writeToFile(PingData data, java.lang.String clustername)`

    - ### Methods inherited from class org.jgroups.protocols.Discovery

      `discoveryRequestReceived, findAllMembers, findAllViews, findAllViewsAsString, findInitialMembers, findInitialMembers, findInitialMembersAsString, getNumberOfDiscoveryRequestsSent, getNumInitialMembers, getNumPingRequests, getTimeout, getView, handleConnect, handleDisconnect, makeView, providedUpServices, resetStats, setNumInitialMembers, setNumPingRequests, setTimeout, up`

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SUFFIX

          protected static final java.lang.String SUFFIX

      See Also:
        Constant Field Values

    - #### location

          protected java.lang.String location

    - #### interval

          protected long interval

    - #### root_dir

          protected java.io.File root_dir

    - #### filter

          protected java.io.FilenameFilter filter

  - ### Constructor Detail

    - #### FILE_PING

          public FILE_PING()

  - ### Method Detail

    - #### init

          public void init()
                    throws java.lang.Exception

      Description copied from class: `Protocol`
      Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.
      Overrides:
        `init` in class `Discovery`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

    - #### start

          public void start()
                     throws java.lang.Exception

      Description copied from class: `Protocol`
      This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.
      Overrides:
        `start` in class `Discovery`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

    - #### stop

          public void stop()

      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Discovery`

    - #### sendGetMembersRequest

          public void sendGetMembersRequest(java.lang.String cluster_name,
                                   Promise promise,
                                   boolean return_views_only)
                                     throws java.lang.Exception

      Specified by:
        `sendGetMembersRequest` in class `Discovery`
      Throws:
        `java.lang.Exception`

    - #### down

          public java.lang.Object down(Event evt)

      Description copied from class: `Discovery`
      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `PassDown`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`. The PING protocol is interested in several different down events, Event.FIND_INITIAL_MBRS - sent by the GMS layer and expecting a GET_MBRS_OK Event.TMP_VIEW and Event.VIEW_CHANGE - a view change event Event.BECOME_SERVER - called after client has joined and is fully working group member Event.CONNECT, Event.DISCONNECT.
      Overrides:
        `down` in class `Discovery`

    - #### createRootDir

          protected void createRootDir()

    - #### handleView

          protected void handleView(View view)

    - #### remove

          protected void remove(java.lang.String clustername,
                    Address addr)

    - #### readAll

          protected java.util.List<PingData> readAll(java.lang.String clustername)

      Reads all information from the given directory under clustername
      Returns:

    - #### readFile

          protected static PingData readFile(java.io.File file)

    - #### writeToFile

          protected void writeToFile(PingData data,
                         java.lang.String clustername)

    - #### addressAsString

          protected java.lang.String addressAsString(Address address)

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.